package ROTool::HTTP::Client;
use strict;
use ROTool;
use ROTool::Client;
use vars qw(@ISA);
#require 'jcode.pl';

my $APPRI_VER = "rotoold-httpd";

@ISA = qw( ROTool::Client ROTool );
my @field_list;

sub typechecker{
    #not a method.
    my $self = shift;
    if($self->{"buf"} =~ /HTTP\/\d+\.\d+/){
	bless $self;
	$self->new();
	return 1;
    }else{
	return 0;
    }
}

sub import{
    # don't delete above line.
    &ROTool::typechecker_regist(\&typechecker);
    
    @field_list = qw(id server area name hp hpmax sp spmax
		     baselv joblv class time message);
}

sub new{
    my $self = shift;
    # It's morph-processor method, not a constractor.
    $self = $self->SUPER::new(@_);
    $self->{"param"}->{"APPRI_VER"} = $APPRI_VER;
    return $self;
}

sub is_client{
    return 1;
}

sub is_server{
    return 0;
}

sub recv{
    my($self) = shift;

    my($ret) = $self->SUPER::recv();
    &ROTool::printlog(4," [oid = $self->{oid}] parse message\n");

    my @client_msg = split(/(\r\n|\r|\n)/,$self->{"buf"});
    while(@client_msg){
	$_ = shift(@client_msg);
	$_ .= shift(@client_msg) if(@client_msg);
	&ROTool::printlog(4,"[oid = $self->{oid}] parse line:{$_}\n");
	if(m{^(GET|HEAD)\s+(.*?)\s+HTTP/(\d+\.\d+)}){
	    $self->{method} = $1;
	    $self->{path}   = $2;
	    $self->{httpVersion} = $3;
	    $self->{header} = {};
	    &ROTool::printlog(4,"  find:$1 $2 $3\n");
	}elsif(m{^(.*?):\s*(.*)$}){
	    $self->{header}->{lc($1)} = $2;
	    &ROTool::printlog(4,"  send message\n");
	}elsif(/^(\r\n|\r|\n)$/){
	    &ROTool::printlog(4,"  send message\n");
	    my $msg;
	    $msg  ="HTTP/1.1 200 OK\r\n";
	    $msg .="Content-Type: text/plain; charset=EUC-JP\r\n";
	    my $body;
	    $body = "³饤ȿ".(scalar(&ROTool::UA_list()) - 1)."\r\n";
	    foreach my $client(&ROTool::UA_list()){
		# Fetch data from UA_list.
		# and make message send to peer client.
		next if $client->{"param"}->{id} eq 'rotoold';
		my $line;
		$line .= sprintf("%-10s %-8s %-16s %-10s HP:%5s/%5s SP:%5s/%5s Lv:%2s/%2s %s %s %s\r\n",@{$client->{"param"}}{@field_list});
		&jcode::convert(\$line,'euc');
		$body .= $line;
	    }
	    $msg .= "Content-Length: ".length($body)."\r\n";
	    $msg .= "\r\n";
	    $msg .= $body;
	    # send message
	    my $sock = $self->{"sock"};
	    $sock->syswrite($msg,length($msg));
	    &ROTool::printlog(4,$msg."\n");
	    $self->{method} = undef;
	    $self->{path}   = undef;
	    if(defined $self->{header}->{connection} &&
	       $self->{header}->{connection} =~ /close/i){
		return -1;
	    }
	}else{
	    &ROTool::printlog(4,"  no match:$_\n");
	}
    }
    $self->{"buf"} = "";
    return $ret;
}
    
sub send{
    my $self = shift;
    return 1;
}
1;

